
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1 Blue
#property indicator_color2 DimGray
#property indicator_color3 Yellow
#property indicator_color4 ForestGreen
#property indicator_color5 Red
#property indicator_color6 Magenta
#property indicator_color7 MidnightBlue

#property indicator_width1 4
#property indicator_width2 1
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 4
#property indicator_width6 5

#define NAME "Better Volume"


extern color   TextColor = Gold;

extern int     NumberOfBars = 1500;
extern string  Note = "0 means Display all bars";
extern int     MAPeriod = 100;
extern int     LookBack = 20;
bool FirstRun;
int ID;
int Window;


double red[],blue[],yellow[],green[],white[],magenta[],v4[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

void Sleep_(int msec)
{
   int start = GetTickCount();
   while(GetTickCount() < start + msec)
   {
      double x = MathArctan(start);
   }
}

int init()
  {

      FirstRun = true;
      Sleep_(1);
      ID = GetTickCount();
      Window = -1;

//---- indicators
      SetIndexBuffer(0,red);
      SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexLabel(0,"Climax High ");
      
      SetIndexBuffer(1,blue);
      SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexLabel(1,"Neutral");
      
      SetIndexBuffer(2,yellow);
      SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexLabel(2,"Low ");
      
      SetIndexBuffer(3,green);
      SetIndexStyle(3,DRAW_HISTOGRAM);
      SetIndexLabel(3,"HighChurn ");
      
      SetIndexBuffer(4,white);
      SetIndexStyle(4,DRAW_HISTOGRAM);
      SetIndexLabel(4,"Climax Low ");
      
      SetIndexBuffer(5,magenta);
      SetIndexStyle(5,DRAW_HISTOGRAM);
      SetIndexLabel(5,"ClimaxChurn ");
      
      SetIndexBuffer(6,v4);
      SetIndexStyle(6,DRAW_LINE,0,2);
      SetIndexLabel(6,"Average("+MAPeriod+")");
      
      IndicatorShortName("Better Volume 1.61" );
      

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  
   double VolLowest,Range,Value2,Value3,HiValue2,HiValue3,LoValue3,tempv2,tempv3,tempv;
   int limit;

   if (FirstRun)
   {
      FirstRun = false;

      string name = NAME + ID;
      IndicatorShortName(name);
      Window = WindowFind(name);
      IndicatorShortName(NAME);
      
      ShowDescription();
   }

   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   if ( NumberOfBars == 0 ) 
      NumberOfBars = Bars-counted_bars;
   limit=NumberOfBars; //Bars-counted_bars;
   
      
   for(int i=0; i<limit; i++)   
      {
         red[i] = 0; blue[i] = Volume[i]; yellow[i] = 0; green[i] = 0; white[i] = 0; magenta[i] = 0;
         Value2=0;Value3=0;HiValue2=0;HiValue3=0;LoValue3=99999999;tempv2=0;tempv3=0;tempv=0;
         
         
         VolLowest = Volume[iLowest(NULL,0,MODE_VOLUME,20,i)];
         if (Volume[i] == VolLowest)
            {
               yellow[i] = NormalizeDouble(Volume[i],0);
               blue[i]=0;
            }
               
         Range = (High[i]-Low[i]);
         Value2 = Volume[i]*Range;
         
         if (  Range != 0 )
            Value3 = Volume[i]/Range;
            
         
         for ( int n=i;n<i+MAPeriod;n++ )
            {
               tempv= Volume[n] + tempv; 
            } 
          v4[i] = NormalizeDouble(tempv/MAPeriod,0);
         
          
          for ( n=i;n<i+LookBack;n++)
            {
               tempv2 = Volume[n]*((High[n]-Low[n])); 
               if ( tempv2 >= HiValue2 )
                  HiValue2 = tempv2;
                    
               if ( Volume[n]*((High[n]-Low[n])) != 0 )
                  {           
                     tempv3 = Volume[n] / ((High[n]-Low[n]));
                     if ( tempv3 > HiValue3 ) 
                        HiValue3 = tempv3; 
                     if ( tempv3 < LoValue3 )
                        LoValue3 = tempv3;
                  } 
            }
                                      
          if ( Value2 == HiValue2  && Close[i] > (High[i] + Low[i]) / 2 )
            {
               red[i] = NormalizeDouble(Volume[i],0);
               blue[i]=0;
               yellow[i]=0;
            }   
            
          if ( Value3 == HiValue3 )
            {
               green[i] = NormalizeDouble(Volume[i],0);                
               blue[i] =0;
               yellow[i]=0;
               red[i]=0;
            }
          if ( Value2 == HiValue2 && Value3 == HiValue3 )
            {
               magenta[i] = NormalizeDouble(Volume[i],0);
               blue[i]=0;
               red[i]=0;
               green[i]=0;
               yellow[i]=0;
            } 
         if ( Value2 == HiValue2  && Close[i] <= (High[i] + Low[i]) / 2 )
            {
               white[i] = NormalizeDouble(Volume[i],0);
               magenta[i]=0;
               blue[i]=0;
               red[i]=0;
               green[i]=0;
               yellow[i]=0;
            } 
            
         
      }
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+



void SetLabel(string name, int window, int x, int y, string text, string font = "Arial Black", color clr = Gold, int size = 8)
{
   ObjectCreate(name, OBJ_LABEL, window, 0, 0);
   
   ObjectSet(name, OBJPROP_CORNER, 0);
   ObjectSet(name, OBJPROP_XDISTANCE, x);
   ObjectSet(name, OBJPROP_YDISTANCE, y);
   ObjectSetText(name, text, size, font, clr);
}

void ShowDescription()
{
   if (Window == -1) return;
   
   SetLabel(ID + "clr0", Window, 20, 0, "~", "Arial Black", indicator_color1, 20);
   SetLabel(ID + "clr1", Window, 20, 10, "~", "Arial Black", indicator_color2, 20);
   SetLabel(ID + "clr2", Window, 20, 20, "~", "Arial Black", indicator_color3, 20);
   SetLabel(ID + "clr3", Window, 20, 30, "~", "Arial Black", indicator_color4, 20);
   SetLabel(ID + "clr4", Window, 20, 40, "~", "Arial Black", indicator_color5, 20);
   SetLabel(ID + "clr5", Window, 20, 50, "~", "Arial Black", indicator_color6, 20);
   SetLabel(ID + "clr6", Window, 20, 60, "~", "Arial Black", indicator_color7, 20);
   
   SetLabel(ID + "txt0", Window, 50, 15, " ", "Arial", TextColor);
   SetLabel(ID + "txt1", Window, 50, 25, " ", "Arial", TextColor);
   SetLabel(ID + "txt2", Window, 50, 35, " ", "Arial", TextColor);
   SetLabel(ID + "txt3", Window, 50, 45, "  ", "Arial", TextColor);
   SetLabel(ID + "txt4", Window, 50, 55, " ", "Arial", TextColor);
   SetLabel(ID + "txt5", Window, 50, 65, " ", "Arial", TextColor);
   SetLabel(ID + "txt6", Window, 50, 75, "Average(" + MAPeriod + ")", "Arial", TextColor);
}
         